﻿namespace WebChat;
interface
uses
  System,
  System.Linq,
  System.Web,
  System.Collections,
  System.Web.Services,
  System.Web.Services.Protocols;


type
  [WebService(&Namespace := 'http://eBob42.org/')]
  [WebServiceBinding(ConformsTo := WsiProfiles.BasicProfile1_1)]
  [System.ComponentModel.ToolboxItem(false)]
  // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
  // [System.Web.Script.Services.ScriptService]
  chat = public class(System.Web.Services.WebService)
  public
    const key = 'chatroom';

    [WebMethod]
    method SendMessage(const User, Message: string);
    [WebMethod]
    method GetMessages(const Start: DateTime): String;
    [WebMethod]
    method GetUserMessages(const User: String): String;
  end;

implementation

type
  ChatMessage = class
  public
    Time: DateTime;
    User: String;
    Message: String;
    constructor(const ATime: DateTime; const AUser, AMessage: String);
  end;

constructor ChatMessage(const ATime: DateTime; const AUser, AMessage: String);
begin
  Time := ATime;
  User := AUser;
  Message := AMessage
end;

// chat

method chat.SendMessage(const User, Message: string);
var
  Messages: ArrayList;
begin
  if not Assigned(Application[key]) then
  begin
    Messages := new ArrayList();
    Application[key] := Messages
  end
  else Messages := Application[key] as ArrayList;
  Messages.Add(ChatMessage.Create(DateTime.Now, User, Message))
end;

method chat.GetMessages(const Start: DateTime): String;
begin
  Result := '';
  if Assigned(Application[key]) then
  begin
    var myEnum: IEnumerator := (Application[key] as ArrayList).GetEnumerator;
    while myEnum.MoveNext do
      if (myEnum.Current as ChatMessage).Time > Start then
        Result := Result + (myEnum.Current as ChatMessage).Time.ToString('yyyy-MM-dd HH:mm:ss') + ' ' + 
          (myEnum.Current as ChatMessage).User + ': ' + 
          (myEnum.Current as ChatMessage).Message + #13#10
  end
end;

method chat.GetUserMessages(const User: String): String;
begin
  Result := '';
  if Assigned(Application[key]) then
  begin
    var myEnum: IEnumerator := (Application[key] as ArrayList).GetEnumerator;
    while myEnum.MoveNext do
      if (myEnum.Current as ChatMessage).User = User then
        Result := Result + (myEnum.Current as ChatMessage).Time.ToString('yyyy-MM-dd HH:mm:ss') + ' ' + 
          (myEnum.Current as ChatMessage).User + ': ' + 
          (myEnum.Current as ChatMessage).Message + #13#10
  end
end;

end.